'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _fs = require('fs');

var _prettier = require('prettier');

exports.default = (files, { config, onWriteFile }) => {
  for (const file of files) {
    const options = _prettier.resolveConfig.sync(file, { config });
    const input = (0, _fs.readFileSync)(file, 'utf8');
    const output = (0, _prettier.format)(input, Object.assign(options, {
      filepath: file
    }));

    if (output !== input) {
      onWriteFile && onWriteFile(file);
      (0, _fs.writeFileSync)(file, output);
    }
  }
};