'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getChangedFiles = exports.getSinceRevision = exports.detect = exports.name = undefined;

var _fs = require('fs');

var _path = require('path');

var _execa = require('execa');

var _execa2 = _interopRequireDefault(_execa);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const name = exports.name = 'git';

const detect = exports.detect = directory => {
  try {
    return (0, _fs.statSync)((0, _path.join)(directory, '.git')).isDirectory();
  } catch (error) {
    return false;
  }
};

const runGit = (directory, args) => _execa2.default.sync('git', args, {
  cwd: directory
});

const getLines = execaResult => execaResult.stdout.split('\n');

const getSinceRevision = exports.getSinceRevision = directory => {
  return runGit(directory, ['merge-base', 'HEAD', 'master']).stdout.trim();
};

const getChangedFiles = exports.getChangedFiles = (directory, revision) => {
  return [...getLines(runGit(directory, ['diff', '--name-only', '--diff-filter=ACMRTUB', revision])), ...getLines(runGit(directory, ['ls-files', '--others', '--exclude-standard']))].filter(Boolean);
};